
;12 digit ASCII decimal to 40 bit binary test
;16-bit code - dedndave

        .MODEL  SMALL
        .STACK  2048

;----------------------------------------------------------------

        .DATA

Buff    db '9999999999999'          ;(13) 9's to test max length

;----------------------------------------------------------------

        .CODE
        ASSUME  DS:DGROUP

_main   PROC FAR

;set the DS register to DGROUP

        mov     ax,@DATA
        mov     ds,ax

;run the test

        mov     si,offset Buff
        call    ascbin12

;terminate

        mov     ax,4C00h            ;function = terminate
        int     21h                 ;DOS function call

_main   ENDP

;----------------------------------------------------------------

ascbin12 proc   near

;   CALL: SI = address of L J ASCII Max 12-digit buffer
;              any non-ASCII numeric may be used to terminate
;RETURNS: BX:DX:AX = binary number (BH always = 0)
;         all other registers are preserved

;save registers

        push    si
        push    di
        push    cx
        push    bp

;initialize max digit count

        mov     di,11               ;max digit count less 1

;initialize registers

        xor     ax,ax
        mov     cx,ax
        mov     bx,ax
        mov     dx,ax

;pre-load the first digit into the accumulator

        mov     al,[si]
        xor     al,30h
        cmp     al,9
        jbe     nxdg3               ;loop entry is nxdg3

;first char is not ASCII numeric - set result to 0 and exit

        mov     al,ch
        jmp short fn12_1

;------------
;top of loop
;------------

;<< multiply the accumulator by 10

;multiply the accumulator by 2

nxdg2:  push    di                  ;save digit count
        shl     ax,1
        rcl     dx,1
        rcl     bl,1

;make a copy of 2X accumulator in BH:BP:DI

        mov     di,ax
        mov     bp,dx
        mov     bh,bl

;multiply the copy by 2 (4X accumulator)

        shl     di,1
        rcl     bp,1
        rcl     bh,1

;multiply the copy by 2 again (8X accumulator)

        shl     di,1
        rcl     bp,1
        rcl     bh,1

;add the two together (8X + 2X = 10X)

        add     ax,di
        adc     dx,bp
        adc     bl,bh
        pop     di                  ;recall digit count

;add the new digit to the accumulator

        add     ax,cx               ;add binary digit value to ax/dx/bl
        adc     dx,0
        adc     bl,ch

;test for max length

        dec     di                  ;dec total #digit processed count
        jz      fn12_0              ;exit if processed max 12 digits

;load the next digit and convert it to binary
;if it's not an ASCII numeric, we are done

nxdg3:  inc     si                  ;inc to next ascii digit in buf
        mov     cl,[si]
        xor     cl,30h              ;remove 30h to cvt digit to binary
        cmp     cl,9                ;exit if just processed/added last digit
        jbe     nxdg2

;all done - zero BH so the 40 bit result is in BX:DX:AX

fn12_0: mov     bh,ch

;restore registers and exit

fn12_1: pop     bp
        pop     cx
        pop     di
        pop     si
        ret

ascbin12 endp

;----------------------------------------------------------------

        END     _main


































































